unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ImgList, ToolWin,
  OleCtrls, SHDocVw, MSHTML, HttpApp, StrUtils, ActiveX,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, DateUtils,
  UIWebBrowser, UrlMon;

type
  TWebDlg = class(TForm)
    WebBrowser1: TUIWebBrowser;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Edit1: TEdit;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    IdHTTP1: TIdHTTP;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    StatusBar1: TStatusBar;
    SpeedButton4: TSpeedButton;
    procedure WebBrowser1DocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure FormCreate(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure WebBrowser1CommandStateChange(Sender: TObject;
      Command: Integer; Enable: WordBool);
    procedure SpeedButton3Click(Sender: TObject);
    procedure WebBrowser1StatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private 錾 }
    GetUserAgent : Boolean;
  public
    { Public 錾 }
    FLVPath : String;
    UserAgent : String;
    Cookie : String;
    LastNavigate : String;
    Referer : String;
    LoadComplete : Boolean;
  end;

var
  WebDlg: TWebDlg;

const
  MODE_NOTHING = 0;
  MODE_YOUTUBE = 10;
  MODE_NICONICO = 20;
  MODE_GOOGLE = 30;
  MODE_YAHOO = 40;

implementation

uses Unit1;

{$R *.dfm}

// p苎
function DeqouteStr(s:WideString; c:WideChar):WideString;
var
      i : Integer;
      Len : Integer;
begin
      Len := Length(s);

      for i := 1 to Len do
      begin
            if (i = 1)and(s[i] = c) then continue;
            if (i = Len)and(s[i] = c) then continue;
            Result := Result + s[i];
      end;
end;

// s苎
function DeleteCRLF(s:String):String;
var
      i : Integer;
      Len : Integer;
begin
      Len := Length(s);

      for i := 1 to Len do
      begin
            if (s[i] = #$0D)or(s[i] = #$0A) then
            begin
                  continue;
            end;

            Result := Result + s[i];
      end;
end;

// "<BODY>USERAGENT</BODY>" USERAGENT؂o
function UAFilter(ARaw:String):String;
const
      BODY_START = '<BODY>';
      BODY_END = '</BODY>';
var
      S,E,Len : Integer;
begin
      S := AnsiPos(BODY_START, ARaw) + Length(BODY_START);
      E := AnsiPos(BODY_END, ARaw);
      Len := E-S;
      Result := Copy(ARaw,S,Len-1);
end;

procedure TWebDlg.WebBrowser1DocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
var
      HTMLSrc : TStringList;
      Address : TStringList;
      ms : TMemoryStream;
      chrSepa,chrWhite  : TSysCharSet;
      Mode : Integer;
      i : Integer;
      RS,RS2,RL,RL2 : Integer;
      Temp : String;
      Variable : TStringList;
      VideoID,t,SecureID : WideString;
      PostData : TStringStream;
begin
      Edit1.Text := URL;
      FLVPath := '';
      Referer := '';
      BitBtn1.Enabled := false;

      Address := TStringList.Create;
      try
            // URL𕪉
            chrSepa   :=   ['/','.'];
            chrWhite  :=   [];
            ExtractHTTPFields(chrSepa,chrWhite,PChar(String(URL)),Address);

            // hCʐU蕪
            if Address.Count > 2 then
            begin
                  Mode := MODE_NOTHING;
                  case AnsiIndexText(Address[3],['youtube','nicovideo','google','yahoo']) of
                        0: Mode := MODE_YOUTUBE;
                        1: Mode := MODE_NICONICO;
                        2: if Address[2] = 'video' then Mode := MODE_GOOGLE;
                        3: if Address[2] = 'videocast' then Mode := MODE_YAHOO;
                  else

                  end;
            end;

            HTMLSrc := TStringList.Create;
            ms := TMemoryStream.Create;
            Variable := TStringList.Create;
            try
                  // \[X擾
                  HTMLSrc.Text := WebBrowser1.OleObject.Document.documentElement.innerHTML;

                  // [U[G[WFg̎o
                  {if GetUserAgent then
                  begin
                        UserAgent := UAFilter(HTMLSrc.Text);
                        GetUserAgent := false;
                        WebBrowser1.Navigate('about:blank');
                        WebBrowser1.Navigate('about:blank');
                  end;
                  }

                  // ǂ̃TCgɂYȂΏI
                  if mode = MODE_NOTHING then exit;

                  // FLV̍ݏ
                  FLVPath := '';

                  // ^CgƃNbL[ݒ
                  if Mode > 0 then
                  begin
                        Form1.Title := (WebBrowser1.Document as IHTMLDocument2).title;
                        Form1.Cookie := (WebBrowser1.Document as IHTMLDocument2).cookie;
                  end;

                  case Mode of

                  // Youtube[h
                  MODE_YOUTUBE :
                        begin
                              Variable.NameValueSeparator := ':';

                              for i := 0 to HTMLSrc.Count-1 do
                              begin
                                    // swfArgs  VideoID  t o
                                    if AnsiPos('var swfArgs',HTMLSrc[i]) > 0 then
                                    begin
                                          RS := AnsiPos('video_id:',HTMLSrc[i]);
                                          RL := Length(HTMLSrc[i]);
                                          Temp := Copy(HTMLSrc[i],RS,RL);
                                          RS2 := AnsiPos(',',Temp);
                                          Variable.Add(Copy(Temp,1,RS2-1));

                                          RS := AnsiPos('t:',HTMLSrc[i]);
                                          RL := Length(HTMLSrc[i]);
                                          Temp := Copy(HTMLSrc[i],RS,RL);
                                          RS2 := AnsiPos(',',Temp);
                                          Variable.Add(Copy(Temp,1,RS2-1));

                                          break;
                                    end;
                              end;

                              VideoID := DeqouteStr(Variable.Values['video_id'],'''');
                              t := DeqouteStr(Variable.Values['t'],'''');

                              if VideoID <> '' then
                              begin
                                    FLVPath := Format('http://www.youtube.com/get_video?video_id=%s&t=%s',[VideoID,t]);
                                    BitBtn1.Enabled := true;
                              end;
                        end;

                  // jRjR惂[h
                  MODE_NICONICO :
                        begin
                              if Address.Count > 5 then
                              begin
                                    // \y[WȊO͏I
                                    if Address[5] <> 'watch' then exit;

                                    VideoID := Address[6];

                                    // KvȏZbg
                                    IdHttp1.Request.Referer := (WebBrowser1.Document as IHTMLDocument2).referrer;
                                    IdHttp1.Request.UserAgent := UserAgent;
                                    IdHttp1.Request.CustomHeaders.Clear;
                                    IdHttp1.Request.CustomHeaders.Add('Cookie:'+(WebBrowser1.Document as IHTMLDocument2).cookie);

                                    // 擾
                                    Variable.NameValueSeparator := '=';
                                    Temp := HTTPDecode(IdHttp1.Get('http://www.nicovideo.jp/api/getflv?v='+VideoID));

                                    // p[^𕪉
                                    chrSepa   :=   ['&'];
                                    chrWhite  :=   [];
                                    ExtractHTTPFields(chrSepa,chrWhite,PChar(String(Temp)),Variable);

                                    FLVPath := Variable.Values['url'];
                                    BitBtn1.Enabled := true;

                                    Referer := 'http://www.nicovideo.jp/flvplayer.swf?ts=' + InttoStr(DateTimeToUnix(Now));
                              end;
                        end;

                  // Google[h
                  MODE_GOOGLE:
                        begin
                              if Address.Count > 5 then
                              begin
                                    VideoID := Address[5];

                                    if AnsiPos('videohosted?docid=',VideoID) = 1 then
                                    begin
                                          Delete(VideoID,1,18);

                                          Variable.NameValueSeparator := '=';
                                          for i := 0 to HTMLSrc.Count-1 do
                                          begin
                                                // embed  secureurl o
                                                if AnsiPos('<embed',HTMLSrc[i]) > 0 then
                                                begin
                                                      RS := AnsiPos('secureurl%3D',HTMLSrc[i]);
                                                      RL := Length(HTMLSrc[i]);
                                                      Temp := Copy(HTMLSrc[i],RS,RL);
                                                      RS2 := AnsiPos('%26',Temp);
                                                      Variable.Add(HTTPDecode(Copy(Temp,1,RS2-1)));
                                                      break;
                                                end;
                                          end;

                                          SecureID := Variable.Values['secureurl'];
                                          if SecureID <> '' then
                                          begin
                                                FLVPath := 'http://bfehkctd.vp.video.l.google.com/videodownload?version=0&secureurl=' + SecureID;
                                          end;


                                          //IdHttp1.Request.CustomHeaders.Clear;
                                          //IdHttp1.Request.CustomHeaders.Add('Cookie:'+(WebBrowser1.Document as IHTMLDocument2).cookie);
                                          //ShowMessage(IdHttp1.Get('http://vp.video.google.com/videotranscript?frame=c&docid'+VideoID+'&type=list'));

                                          BitBtn1.Enabled := true;
                                          //FLVPath := 'http://vp.video.google.com/videotranscript?frame=c&docid'+VideoID+'&type=list';

                                    end;
                              end;
                        end;
                  MODE_YAHOO:
                        begin
                              if Address.Count > 8 then
                              begin
                                    VideoID := Address[8];

                                    if AnsiPos('?vid=',VideoID) = 1 then
                                    begin
                                          Delete(VideoID,1,5);

                                          PostData := TStringStream.Create('method=getPlayerVideoData&vid=' + VideoID+#13#10);
                                          try
                                                PostData.Seek(0,0);
                                                IdHttp1.Request.CustomHeaders.Clear;
                                                IdHttp1.Request.CustomHeaders.Add('Cookie:'+(WebBrowser1.Document as IHTMLDocument2).cookie);
                                                IdHttp1.Request.CustomHeaders.Add('x-flash-version: 9,0,28,0');
                                                IdHttp1.Request.UserAgent := UserAgent;
                                                IdHttp1.Request.Referer := 'http://videocast.yahoo.co.jp/player/vsu.swf?vid='+VideoID+'&src=vsu&c=&star=0&rpsv=';
                                                IdHttp1.Request.ContentType := 'application/x-www-form-urlencoded';

                                                HTMLSrc.Text := IdHttp1.Post('http://videocast.yahoo.co.jp/rest/',TStream(PostData));

                                                for i := 0 to HTMLSrc.Count-1 do
                                                begin
                                                      // <Url type="flv">  secureurl o
                                                      if AnsiPos('<Url type="flv">',HTMLSrc[i]) > 0 then
                                                      begin
                                                            RS := AnsiPos('>',HTMLSrc[i])+1;
                                                            RL := Length(HTMLSrc[i]);
                                                            Temp := Copy(HTMLSrc[i],RS,RL);
                                                            RS2 := AnsiPos('<',Temp);
                                                            FLVPath := Copy(Temp,1,RS2-1);
                                                            BitBtn1.Enabled := true;
                                                            break;
                                                      end;
                                                end;
                                          finally
                                                PostData.Free;
                                          end;
                                    end; // if
                              end;// if
                        end; // case
                  end;// switch
            finally
                  HTMLSrc.Free;
                  ms.Free;
                  Variable.Free;
            end;

      finally
            Address.Free;
      end;

      LastNavigate := URL;
      LoadComplete := true;
end;

procedure TWebDlg.FormCreate(Sender: TObject);
var
      Buf : Array [0..1024] of char;
      BufferLength : Cardinal;
begin
      WebBrowser1.Navigate('about:blank');
      //GetUserAgent := true;
      //WebBrowser1.Navigate('javascript:navigator.userAgent');
      BufferLength := 1024;
      UrlMkGetSessionOption(URLMON_OPTION_USERAGENT,@Buf,BufferLength,BufferLength,0);
      UserAgent := Buf;
end;

procedure TWebDlg.ToolButton1Click(Sender: TObject);
begin
      WebBrowser1.GoBack;
end;

procedure TWebDlg.ToolButton2Click(Sender: TObject);
begin
      WebBrowser1.GoForward;
end;

procedure TWebDlg.ToolButton3Click(Sender: TObject);
begin
      WebBrowser1.Refresh;
end;

procedure TWebDlg.ToolButton4Click(Sender: TObject);
begin
      WebBrowser1.Stop;
end;

procedure TWebDlg.ToolButton6Click(Sender: TObject);
begin
      WebBrowser1.GoHome;
end;

procedure TWebDlg.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
      if key = #13 then
      begin
            key := #0;
            WebBrowser1.Navigate(Edit1.Text);
      end;
end;

procedure TWebDlg.BitBtn1Click(Sender: TObject);
begin
      Self.Close;
      Form1.Load(FLVPath);
end;

procedure TWebDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
      WebBrowser1.Navigate('about:blank');
end;

procedure TWebDlg.SpeedButton1Click(Sender: TObject);
begin
      WebBrowser1.Navigate('http://jp.youtube.com/');
end;

procedure TWebDlg.SpeedButton2Click(Sender: TObject);
begin
      WebBrowser1.Navigate('http://www.nicovideo.jp/');
end;

procedure TWebDlg.FormShow(Sender: TObject);
begin
      if ToolButton1.Enabled then WebBrowser1.GoBack;
end;

procedure TWebDlg.WebBrowser1CommandStateChange(Sender: TObject;
  Command: Integer; Enable: WordBool);
begin
      case Command of
            CSC_NAVIGATEBACK : ToolButton1.Enabled := Enable;
            CSC_NAVIGATEFORWARD : ToolButton2.Enabled := Enable;
      end;
end;

procedure TWebDlg.SpeedButton3Click(Sender: TObject);
begin
      WebBrowser1.Navigate('http://video.google.com/');
end;

procedure TWebDlg.WebBrowser1StatusTextChange(Sender: TObject;
  const Text: WideString);
begin
      StatusBar1.Panels.Items[0].Text := Text;
end;

procedure TWebDlg.SpeedButton4Click(Sender: TObject);
begin
      WebBrowser1.Navigate('http://videocast.yahoo.co.jp/');
end;

end.
