unit Unit5;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ActiveX;

type
  TFreedomWin = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  FreedomWin: TFreedomWin;

implementation

uses Unit1;

{$R *.dfm}

procedure TFreedomWin.FormClose(Sender: TObject; var Action: TCloseAction);
begin
      Timer1.Enabled := false;
end;

procedure TFreedomWin.Timer1Timer(Sender: TObject);
var
      bmp: TBitmap;
begin
      if Assigned(ShockWaveFlash1) then
      begin
            bmp := TBitmap.Create;
            try
                  bmp.Width := Form1.MovieWidth;
                  bmp.Height := Form1.MovieHeight;

                  OleDraw(
                        ShockWaveFlash1.ControlInterface,
                        DVASPECT_CONTENT,
                        bmp.Canvas.Handle,
                        Rect(0, 0, bmp.Width, bmp.Height)
                  );

                  FreedomWin.Image1.Picture.Bitmap.Assign(bmp);
                  //bmp.SaveToFile('X:\TEST2.bmp');
            finally
                  bmp.Free;
            end;
      end;


end;

procedure TFreedomWin.FormCreate(Sender: TObject);
begin
      Self.DoubleBuffered := true;
end;

procedure TFreedomWin.FormShow(Sender: TObject);
begin
      Timer1.Enabled := true;
end;

end.
