unit Unit8;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ExtDlgs, JPEG, GLDPNG, Menus;

type
  TRenDlg = class(TForm)
    Image1: TImage;
    PopupMenu1: TPopupMenu;
    S1: TMenuItem;
    SaveDialog1: TSaveDialog;
    procedure S1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OnMoving(var Msg:TMessage); message WM_MOVING;
    procedure MoveEvent;
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  RenDlg: TRenDlg;

implementation

uses Unit1;

{$R *.dfm}

procedure TRenDlg.S1Click(Sender: TObject);
begin
      if SaveDialog1.Execute then
      begin
            Image1.Picture.SaveToFile(SaveDialog1.FileName);
      end;
end;

procedure TRenDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
      Self.MoveEvent;
      Form1.RenUnRegister(Self);
      Self.Release;
end;

procedure TRenDlg.MoveEvent;
begin
      Unit1.RenX := Self.Left;
      Unit1.RenY := Self.Top;
end;

procedure TRenDlg.OnMoving(var Msg:TMessage);
begin
      MoveEvent;
end;

end.
